function PNRiseThirst( diff : int ) {
	if ( diff > 1 ) {
		if (!PNPeekMeditationFlag()) {
			if (diff / PNGetThirstCounter() >= PNGetThirstMaxFastTravel()) {
				diff = PNGetThirstMaxFastTravel() * PNGetThirstCounter();
			}
		}
		PNDrink( RoundMath(((float) diff / (float) PNGetThirstCounter()) * ( -1 ) * PNGetThirstMeditationMult()));
	} else {
		PNDecThirstCnt( PNGetThirstInc() );
	}
}

function PNGetThirstInc() : float {
	var combatadd : float;
	var healthadd : float;
	var totaladd : float;
	var staminaadd : float;
	var adrenalineadd : float;
	var toxadd : float;
	
	combatadd = 0;
	if ( thePlayer.IsInCombat() ) {
		combatadd = PNGetThirstCombatAdd();
	}
	healthadd = (1 - (thePlayer.GetStat(BCS_Vitality) / thePlayer.GetStatMax(BCS_Vitality))) * PNGetThirstVitalityAdd();
	staminaadd = (1 - (thePlayer.GetStat(BCS_Stamina) / thePlayer.GetStatMax(BCS_Stamina))) * PNGetThirstStaminaAdd();
	adrenalineadd = (thePlayer.GetStat(BCS_Focus) / thePlayer.GetStatMax(BCS_Focus)) * PNGetThirstAdrenalineAdd();
	toxadd = (thePlayer.GetStat(BCS_Toxicity) / thePlayer.GetStatMax(BCS_Toxicity)) * PNGetThirstToxAdd();
	totaladd = 1 + combatadd + healthadd + staminaadd - adrenalineadd - toxadd;
	if (totaladd < 0) { totaladd = 0; } 
	return totaladd;
}

function PNDrink( drink : int ) {
	var over : int;
	if ( PNThirstOn() ) {
		over = PNGetThirst() - drink;
		if ( over < 0 ) {
			PNSetFatigue( PNGetFatigue() - over );
		}
		PNSetThirst( PNGetThirst() - drink );
		PNResetThirstCnt();
	}
}
