function PNDecrementDay()
{
	var items : array<SItemUniqueId>;
	var i : int;
	var currDay : int;
	var _inv : CInventoryComponent;
	
	_inv = thePlayer.GetInventory();
	
	_inv.GetAllItems(items);
	
	for(i=items.Size()-1; i>=0; i-=1)
	{
		if (_inv.ItemHasTag( items[i], 'mod_food') && !_inv.ItemHasTag( items[i], 'no_expire' )) 
		{
		
		currDay = PNGetItemAttributeValue(_inv.GetItemAttributeValue( items[i], 'expire' ));

			switch(currDay) {
				case 5:
					_inv.RemoveItemBaseAbility(items[i], 'expire_day_5');
					_inv.AddItemBaseAbility(items[i], 'expire_day_4');
					break;
				case 4:
					_inv.RemoveItemBaseAbility(items[i], 'expire_day_4');
					_inv.AddItemBaseAbility(items[i], 'expire_day_3');
					break;
				case 3:
					_inv.RemoveItemBaseAbility(items[i], 'expire_day_3');
					_inv.AddItemBaseAbility(items[i], 'expire_day_2');
					break;
				case 2:
					_inv.RemoveItemBaseAbility(items[i], 'expire_day_2');
					_inv.AddItemBaseAbility(items[i], 'expire_day_1');
					break;
				case 1:
					_inv.RemoveItemBaseAbility(items[i], 'expire_day_1');
					_inv.AddItemBaseAbility(items[i], 'expire_day_0');
					break;
				default: break;
			}
			
			currDay = currDay - 1;
			
			if (currDay <= 0) 
			{
				_inv.RemoveItem( items[i], _inv.GetItemQuantity( items[i] ));
			}
		}
	}
}

function PNGetExpireLevel( _inv : CInventoryComponent, itemId : SItemUniqueId) : int {
	var exp : int;
	
	exp = PNGetItemAttributeValue(_inv.GetItemAttributeValue( itemId, 'expire' ));
	if ( exp <= 0 ) return 1;
	else return exp;
}
