function PNEffects() {
	if ( PNHungerOn() ) PNHungerEffects();
	if ( PNFatigueOn() ) PNFatigueEffects();
}

// ==========
//   Hunger
// ==========

function PNHungerEffects() {
	if (PNGetHunger() >= 50) {
		thePlayer.abilityManager.DrainVitality( PNGetHungerEffectsMult() );
	}
}

function PNGetHungerEffectsMult() : float {
	if ( PNHungerOn() ) {
		return (float) PNGetHungerDamage() * ( (float) PNGetHunger() / 100 );
	} else {
		return 0;
	}
}

function PNGetHungerAdrenalineDrain() : float {
	if (PNHungerOn()) {
		return 1.5 - ((float) PNGetHunger() / 100 );
	} else {
		return 1;
	}
}

// ==========
//   Thirst
// ==========

function PNGetThirstStaminaRegenMult() : float {
	if ( PNThirstOn() ) {
		return 1.5 - ( (float) PNGetThirst() / 100 );
	} else {
		return 1;
	}
}

// ===========
//   Fatigue
// ===========

function PNFatigueEffects() {
	if ( PNFatigueLevel2() ) {
		thePlayer.SetWalkToggle( true );
	}
}

function PNFatigueLevel1() : bool {
	return PNGetFatigue() >= 35;
}

function PNFatigueLevel2() : bool {
	return PNGetFatigue() >= 65;
}